using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement;
using EntityManagement.BusinessInterface;

namespace ConsoleApplication1
{
    class Program
    {
        static Random theRandom = new Random();

        static string SessionSuffix
        {
            get { return string.Format("{0:0009}", theRandom.Next(1000)); }
        }

        static void Main(string[] args)
        {
            // lookup industry
            Industry i1 = new IndustryFinder().GetById(1);

            // lookup country
            Country portugal = new CountryFinder().GetByName(Country.CountryName.Portugal);
            
            // lookup Person
            Person p1 = new PersonFinder().GetById(3);
            Console.WriteLine("lookup person with ID {0}: {1}", 3, p1.Name);

            // lookup Organization
            Organization o1 = new OrganizationFinder().GetById(1);
            Console.WriteLine("lookup organization with ID {0}: {1}", 1, o1.Name);

            // get entity
            Entity e4 = new EntityFinder().GetById(4);
            Console.WriteLine("lookup entity with ID {0}: {1} ({2})", 4, e4.Name, e4.GetType());

            // get entity (allready in memory)
            Entity e1 = new EntityFinder().GetById(1);
            Console.WriteLine("lookup entity with ID {0}: {1} ({2})", 1, e1.Name, e1.GetType());

            // add person
            IEntityManagement bus = new EntityManagementService();
            string name = "Carlota Alexandra " + SessionSuffix;
            PersonData pdata = new PersonData(name, "101202303", DateTime.Now /*new DateTime(2006, 01, 01)*/);
            int pid = bus.AddPerson(pdata);
            Console.WriteLine("Inseriu a pessoa {0} com ID {1}", name, pid);

            // add (unattached) address
            name = "R. S. Tome " + SessionSuffix;
            AddressData adata = new AddressData(name, null, "Porto", portugal.ID);
            int aid = bus.AddAddress(adata, null);
            Console.WriteLine("Inseriu a morada {0} com ID {1}", name, aid);

            // attach address
            bus.AttachAddressToEntity(aid, pid, true);
            Console.WriteLine("Atribuiu a morada {0}  pessoa {1}", aid, pid);

            // add person with address
            Person p = new Person();
            p.Name = "Carlos " + SessionSuffix;
            p.Nif = "999888777";
            Address a = new Address("Rua do Carlos " + SessionSuffix, null, "D Fundo", portugal);
            p.AddAddress(a);
            p.Save();
            Console.WriteLine("Inseriu uma nova pessoa ({0}) com uma nova morada {1}", p.ID, a.ID);

            // attach 2nd address
            bus.AttachAddressToEntity(a.ID, pid, false);
            Console.WriteLine("Atribuiu a morada {0}  pessoa {1}", a.ID, pid);

            // load pessoa
            p = new PersonFinder().GetById(pid);
            Console.WriteLine("A Pessoa {0} tem {1} morada(s)", p.Name, p.Addresses.Count);

            // wait
            Console.WriteLine("\nPress any key to continue...");
            Console.ReadLine();
        }
    }
}
