using System;
using System.Collections.Generic;
using System.Text;

namespace EntityManagement.BusinessInterface
{
    // a Faade to the EntityManagement component.
    // may be used for testing purposes
    public class EntityManagementService : IEntityManagement
    {
        #region IEntityManagement Members

        public int AddPerson(PersonData pdata)
        {
            Person p = new Person();
            p.Name = pdata.Name;
            p.Nif = pdata.Nif;
            p.DateOfBirth = pdata.DateOfBirth;
            p.Save();
            return p.ID;
        }

        public int AddOrganization(OrganizationData odata)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public EntityData GetEntity(int key)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IList<PersonData> GetPersons(string nameFilter)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IList<OrganizationData> GetOrganizations(string nameFilter)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public int AddAddress(AddressData adata, int? keyToEntity)
        {
            Address a = new Address();
            a.Street = adata.Street;
            a.Street2 = adata.Street2;
            a.Local = adata.Local;
            a.Country = new CountryFinder().GetById(adata.Country);
            a.Save();
            return a.ID;
        }

        public AddressData GetAddress(int key)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IList<AddressData> GetAddressesForEntity(int keyEntity)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void AttachAddressToEntity(int keyAddress, int keyEntity, bool isPrimary)
        {
            Entity e = new EntityFinder().GetById(keyEntity);
            Address a = new AddressFinder().GetById(keyAddress);
            e.AddAddress(a);
            e.Save();
        }

        public EntityData GetEntity(string nif)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IList<EntityData> GetEntities(string nameFilter)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IList<AddressData> GetAddresses(string streetFilter, string localFilter)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetPrimaryAddress(int keyEntity, int keyAddress)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
    }
}
