using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class AddressOfEntity : ActiveRecord
    {
        Address address;

        public Address Address
        {
            get { return address; }
        }

        Entity entity;

        public Entity Entity
        {
            get { return entity; }
        }

        bool isPrimary;

        public bool IsPrimary
        {
            get { return isPrimary; }
            set
            {
                isPrimary = value;
                SetDirty();
            }
        }

        public AddressOfEntity(Address a, Entity e)
        {
            this.address = a;
            this.entity = e;
        }

        #region DAL

        protected override IDictionary<string, object> GetParameterValues()
        {
            IDictionary<string, object> parms = new Dictionary<string, object>();
            parms.Add("entityid", entity.ID);
            parms.Add("addressid", address.ID);
            parms.Add("isprimary", isPrimary);
            return parms;
        }

        internal override string TableName
        {
            get { return TableNames.AddressesOfEntities; }
        }

        internal AddressOfEntity(System.Data.DataRow r)
            : base(r)
        {
            this.address = new AddressFinder().GetById( (int)r["addressid"]);
            this.entity = new EntityFinder().GetById((int)r["entityid"]);
            this.isPrimary = (bool)r["isprimary"];
        }

        protected override void OnBeforeSave()
        {
            //garantir que os outros objectos j tem ID
            if (address.IsNew)
                address.Save();
            if (entity.IsNew)
                entity.Save();
        }

        #endregion
    }
}
