using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    internal class AddressOfEntityFinder : Finder
    {
        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            return new AddressOfEntity(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.AddressesOfEntities; }
        }

        public IList<AddressOfEntity> GetByEntity(Entity e /*int id*/)
        {
            IList<AddressOfEntity> ret = new List<AddressOfEntity>();
            foreach(ActiveRecord aoe in LoadByForeignKey("entityid", e.ID /*id*/))
                ret.Add( (AddressOfEntity)aoe );
            return ret;
        }

        internal IList<AddressOfEntity> GetByAddress(Address a /*int id*/)
        {
            IList<AddressOfEntity> ret = new List<AddressOfEntity>();
            foreach (ActiveRecord aoe in LoadByForeignKey("addressid", a.ID /*id*/))
                ret.Add((AddressOfEntity)aoe);
            return ret;
        }
    }
}
