using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    // apenas consulta valores existentes na tabela (no tem save)
    public class Country : ActiveRecord
    {
        string name;

        public string Name
        {
            get { return name; }
        }

        public enum CountryName { Portugal, Spain, Germany, England, France };

        #region DAL

        internal Country(DataRow r) : base(r)
        {
            name = (string)r["name"];
        }

        // no save for this object
        public override void Save()
        {
            throw new InvalidOperationException("this object cannot perform this method");
        }

        // no delete for this object
        public override void Delete()
        {
            throw new InvalidOperationException("this object cannot perform this method");
        }

        protected override IDictionary<string, object> GetParameterValues()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        internal override string TableName
        {
            get { return TableNames.Countries; }
        }

        #endregion
    }
}
