using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class CountryFinder : Finder
    {
        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            return new Country(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.Countries; }
        }

        public Country GetById(int id)
        {
            return (Country)LoadById(id);
        }

        public Country GetByName(Country.CountryName name)
        {
            Country c = (Country)LoadByStringField("name", name.ToString(), true)[0];
            return c;
        }

        public Country GetByName(string name)
        {
            Country c = (Country)LoadByStringField("name", name, true)[0];
            return c;
        }
    }
}
