using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class EntityFinder : Finder
    {
        public Entity GetById(int id)
        {
            //Entity e = new PersonFinder().GetById(id);
            //if (e != null)
            //    return e;

            //e = new OrganizationFinder().GetById(id);
            //if (e != null)
            //    return e;

            //return null;

            return (Entity)LoadById(id);
        }

        public IList<Entity> GetAll()
        {
            IList<Entity> ret = new List<Entity>();

            //foreach (Person p in new PersonFinder().GetAll())
            //    ret.Add(p);
            //foreach (Organization o in new OrganizationFinder().GetAll())
            //    ret.Add(o);

            foreach (ActiveRecord e in LoadAll())
                ret.Add( (Entity)e );

            return ret;
        }

        public IList<Entity> GetAll(string nameFilter)
        {
            IList<Entity> ret = new List<Entity>();

            //foreach (Person p in new PersonFinder().GetAll(nameFilter))
            //    ret.Add(p);
            //foreach (Organization o in new OrganizationFinder().GetAll(nameFilter))
            //    ret.Add(o);

            foreach (ActiveRecord e in LoadByStringField("name", nameFilter, false))
                ret.Add((Entity)e);

            return ret;
        }

        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            if ( (byte)dataRow["type"] == 0)
                return new Person(dataRow);
            else
                return new Organization(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.Entities; }
        }
    }
}
