using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class IndustryFinder : Finder
    {
        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            return new Industry(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.Industries; }
        }

        public Industry GetById(int id)
        {
            return (Industry)LoadById(id);
        }

        public Industry GetByName(Industry.IndustryName name)
        {
            return (Industry)LoadByStringField("name", name.ToString(), true);
        }

        public Industry GetByName(string name)
        {
            return (Industry)LoadByStringField("name", name, true);
        }
    }
}
