using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class Organization : Entity
    {
        Industry industry;

        public Industry Industry
        {
            get { return industry; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException();
                industry = value;

                SetDirty();
            }
        }

        bool isNGO;

        public bool IsNGO
        {
            get { return isNGO; }
            set
            {
                isNGO = value;
                SetDirty();
            }
        }

        #region DAL

        protected override IDictionary<string, object> GetParameterValues()
        {
            IDictionary<string, object> parms = base.GetParameterValues();
            parms.Add("idindustry", industry.ID);
            parms.Add("isNGO", isNGO);
            return parms;
        }

        internal override string TableName
        {
            get { return TableNames.Organizations; }
        }

        internal Organization(System.Data.DataRow r) : base(r)
        {
            isNGO = (bool)r["isngo"];
            industry = new IndustryFinder().GetById((int)r["idindustry"]);
        }
        #endregion
    }
}
