using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class OrganizationFinder : Finder
    {
        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            return new Organization(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.Organizations; }
        }

        public Organization GetById(int id)
        {
            return (Organization)LoadById(id);
        }

        public IList<Organization> GetAll()
        {
            IList<Organization> ret = new List<Organization>();
            foreach (ActiveRecord o in LoadAll())
                ret.Add( (Organization)o );
            return ret;
        }

        public IList<Organization> GetAll(string nameFilter)
        {
            IList<Organization> ret = new List<Organization>();
            foreach (ActiveRecord o in LoadByStringField("name", nameFilter, false))
                ret.Add((Organization)o);
            return ret;
        }

        protected override string AdditionalFilter
        {
            get
            {
                return "type = 1";
            }
        }
    }
}
