using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class Person : Entity
    {
        public Person()
            : base()
        {
        }

        DateTime dateOfBirth;

        public DateTime DateOfBirth
        {
            get { return dateOfBirth; }
            set
            {
                dateOfBirth = value;
                SetDirty();
            }
        }

        public int Age
        {
            get
            {
                TimeSpan ts = DateTime.Now - dateOfBirth;
                return ts.Days / 365;
            }
        }

        #region DAL

        protected override IDictionary<string, object> GetParameterValues()
        {
            IDictionary<string, object> parms = base.GetParameterValues();
            parms.Add("dateOfBirth", dateOfBirth);
            return parms;
        }

        internal override string TableName
        {
            get { return TableNames.Persons; }
        }

        internal Person(System.Data.DataRow r)
            : base(r)
        {
            dateOfBirth = (DateTime)r["dateOfBirth"];
        }
        #endregion
    }
}
