using System;
using System.Collections.Generic;
using System.Text;

using EntityManagement.ActiveRecordFramework;

namespace EntityManagement
{
    public class PersonFinder : Finder
    {
        protected override ActiveRecord CreateFromData(System.Data.DataRow dataRow)
        {
            return new Person(dataRow);
        }

        protected override string TableName
        {
            get { return TableNames.Persons; }
        }

        public Person GetById(int id)
        {
            return (Person)LoadById(id);
        }

        public IList<Person> GetAll()
        {
            IList<Person> ret = new List<Person>();
            foreach (ActiveRecord o in LoadAll())
                ret.Add( (Person)o );
            return ret;
        }

        public IList<Person> GetAll(string nameFilter)
        {
            IList<Person> ret = new List<Person>();
            foreach (ActiveRecord o in LoadByStringField("name", nameFilter, false))
                ret.Add((Person)o);
            return ret;
        }

        protected override string AdditionalFilter
        {
            get
            {
                return "type = 0";
            }
        }
    }
}
